package task.db;

import com.google.java.contract.Ensures;
import com.google.java.contract.Invariant;
import com.google.java.contract.Requires;

public abstract class Database {

	@Requires({
			"name != null",
			"isRegistered(name) == false",
			"passwd != null"
	})
	@Ensures("isRegistered(name) == true")
	public abstract void register(String name, String passwd);
	
	public abstract void login(String name, String passwd);
	
	public abstract void logout(String name);
	
	public abstract Integer readData(String name, Integer key);
	
	public abstract void addData(String name, Integer key, Integer value);
	
	protected abstract boolean isRegistered(String name);
	protected abstract boolean isLoggedin(String name);
}
